// ---------------------------------------------------------------------------
//	Scheduling class
//	Copyright (C) cisc 1999.
// ---------------------------------------------------------------------------
//	$Id: schedule.h,v 1.7 1999/04/11 13:45:33 cisc Exp $

#ifndef common_schedule_h
#define common_schedule_h

#include "device.h"

class Scheduler
{
public:
	struct Event
	{
	private:
		int count;			// Ԏc
		Device* inst;
		Device::TimeFunc func;
		int arg;
		int time;			// 

		friend class Scheduler;
	};

public:
	Scheduler();
	virtual ~Scheduler();

	bool Init(int maxevents = 16);
	int Proceed(int ticks);

	Event* AddEvent(int count, Device* dev, Device::TimeFunc func, int arg=0, bool repeat=false);
	void SetEvent(Event* ev, int count, Device* dev, Device::TimeFunc func, int arg=0, bool repeat=false);
	bool DelEvent(Device* dev);
	bool DelEvent(Event* ev);

	int GetTime() { return GetTicks() + time; }

private:
	virtual int Execute(int ticks) = 0;
	virtual void Shorten(int ticks) = 0;
	virtual int GetTicks() = 0;

private:
	
	Event* events;
	int evmax;
	int evlast;
	int time;		// ?
	int etime;		// ?
};

#endif // common_schedule_h
