// ---------------------------------------------------------------------------
//	FM Sound Generator
//	Copyright (C) cisc 1999.
// ---------------------------------------------------------------------------
//	x86/VC engine
// ---------------------------------------------------------------------------
//	$Id: fmgenx86.h,v 1.3 1999/06/26 07:46:41 cisc Exp $

#undef THIS
#define THIS	[esi]this
#define OP(n)	[esi]this.op[(n) * TYPE Operator]
#define BUF(n)	[esi]this.buf[(n) * TYPE int]
#define OPD		[edi]op

// -------------------------------------------------------- without LFO

#define OPCALC(n)	\
	__asm { lea edi,OP(n-1) } \
	__asm {	mov	ebx,OPD.egcount } \
	__asm {	mov	ecx,OPD.egdcount } \
	__asm { mov edx,OPD.eglimit } \
	__asm {	add	ebx,ecx } \
	__asm {	cmp	ebx,edx } \
	__asm {	mov	OPD.egcount,ebx } \
	__asm { jnb	op##n##_phase } \
	op##n##_1: \
	__asm {	shr ebx,FM_EGCBITS } \
	__asm {	mov	edx,OPD.pgcount } \
	__asm {	mov	eax,OPD.pgdcount } \
	__asm {	mov	ecx,dltable[ebx * 4] } \
	__asm {	mov	ebx,THIS.in[(n-2) * 4] } \
	__asm { add edx,eax } \
	__asm {	mov	eax,[ebx] } \
	__asm {	imul ecx,OPD.tllinear } \
	__asm {	sal	eax,2 + IS2EC_SHIFT } \
	__asm {	mov OPD.pgcount,edx } \
	__asm {	add	edx,eax } \
	__asm { shr ecx,16 } \
	__asm {	shr	edx,20+FM_PGBITS-FM_OPSINBITS-2 } \
	__asm {	mov	ebx,THIS.out[(n-2) * 4] } \
	__asm {	and	edx,(FM_OPSINENTS-1)*4 } \
	__asm { imul ecx,sinetable[edx] } \
	__asm { mov eax,OP(n-1).out }

ISample Channel4::Calc()
{
	__asm
	{
		xor		eax,eax
		mov		esi,ecx						// = this
		mov		BUF(1),eax
		mov		edx,OP(0).egcount			// egcount += egdcount
		mov		ecx,OP(0).egdcount
		mov		BUF(2),eax
		add		edx,ecx
		mov		ebx,OP(0).eglimit			// egcount < eglimit ?
		mov		BUF(3),eax
		cmp		edx,ebx
		mov		OP(0).egcount,edx
		jnb		op1_phase
op1_1:
		shr		edx,FM_EGCBITS
		mov		eax,OP(0).pgdcount
		mov		edi,OP(0).pgcount
		mov		ebx,dltable[edx * 4]
		mov		ecx,THIS.fb
		add		eax,edi
		imul	ebx,OP(0).tllinear
		shr		ebx,16
		cmp		ecx,31
		mov		OP(0).pgcount,eax
		mov		edx,OP(0).out
		
		jne		op1_fb

		shr		eax,20+FM_PGBITS-FM_OPSINBITS-2
		and		eax,(FM_OPSINENTS-1)*4
		imul	ebx,sinetable[eax]
		add		edx,ebx
		mov		OP(0).out,ebx
		sar		edx,1
		jmp		op1_2

op1_fb:
		// ebx = A   eax = 
		lea		edi,[edx*2+edx]				// edi = last out
		sal		edx,2 + IS2EC_SHIFT
		sar		edx,cl
		add		eax,edx						// eax = +FB
		sar		eax,20+FM_PGBITS-FM_OPSINBITS-2
		and		eax,(FM_OPSINENTS-1)*4
		imul	ebx,sinetable[eax]
		lea		edx,[ebx*4+ebx]
		mov		OP(0).out,ebx
		add		edx,edi
		sar		edx,3
op1_2:
		mov		BUF(0),edx
	}
//op2:
	OPCALC(2)
	__asm { add eax, ecx }
	__asm { mov OP(1).out, ecx }
	__asm { sar eax, 1 }
	__asm {	add	[ebx],eax }

	OPCALC(3)
	__asm { add eax, ecx }
	__asm { mov OP(2).out, ecx }
	__asm { sar eax, 1 }
	__asm {	add	[ebx],eax }
	
	OPCALC(4)
	__asm
	{
		mov OP(3).out, ecx
		add eax,ecx
		pop	edi
		mov ecx,[ebx]
		sar eax,1
		pop	esi
		add	eax,ecx
		pop	ebx
		pop ecx
		pop	ebp
		ret 0
	}

op1_phase:
	op[0].ShiftPhase(Operator::next);
	__asm mov	edx,OP(0).egcount
	__asm jmp	op1_1
op2_phase:
	op[1].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(1).egcount
	__asm jmp	op2_1
op3_phase:
	op[2].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(2).egcount
	__asm jmp	op3_1
op4_phase:
	op[3].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(3).egcount
	__asm jmp	op4_1
	return 0;
}

#undef OPCALC

// -------------------------------------------------------- with LFO

#define OPCALC(n)	\
	__asm { lea edi,OP(n-1) } \
	__asm {	mov	ebx,OPD.egcount } \
	__asm { mov edx,OPD.eglimit } \
	__asm {	add	ebx,OPD.egdcount } \
	__asm {	cmp	ebx,edx } \
	__asm {	mov	OPD.egcount,ebx } \
	__asm { jnb	op##n##_phase } \
	op##n##_1: \
	__asm {	shr ebx,FM_EGCBITS } \
	__asm {	mov	eax,dltable[ebx * 4] } \
	__asm {	imul eax,OPD.tllinear } \
	__asm { test OPD.amon,-1 } \
	__asm { jz op##n##_noamon } \
	__asm { mul THIS.amc } \
	__asm {	mov	eax,OPD.pgdcount } \
	__asm { mov ecx,edx } \
	__asm { jmp op##n##_2 } \
	op##n##_noamon: \
	__asm { mov ecx,eax } \
	__asm {	mov	eax,OPD.pgdcount } \
	__asm { shr ecx,16 } \
	op##n##_2: \
	__asm { mul THIS.pmc } \
	__asm {	mov	ebx,OPD.pgcount } \
	__asm { shrd eax,edx,16 } \
	__asm {	mov	edx,THIS.in[(n-2) * 4] } \
	__asm { add ebx,eax } \
	__asm {	mov	eax,[edx] } \
	__asm {	mov OPD.pgcount,ebx } \
	__asm {	sal	eax,2 + IS2EC_SHIFT } \
	__asm {	add	ebx,eax } \
	__asm {	shr	ebx,20+FM_PGBITS-FM_OPSINBITS-2 } \
	__asm {	and	ebx,(FM_OPSINENTS-1)*4 } \
	__asm { imul ecx,sinetable[ebx] } \
	__asm {	mov	ebx,THIS.out[(n-2) * 4] } \
	__asm { mov eax,OP(n-1).out }

ISample Channel4::Calc2(uint lfo)
{
	__asm
	{
		xor		edx,edx
		mov		esi,ecx						// = this
		mov		BUF(1),edx
		mov		eax,lfo
		mov		ebx,THIS.ams
		mov		BUF(2),edx
		mov		ecx,[ebx+eax*4]
		mov		BUF(3),edx
		mov		ebx,THIS.pms
		mov		edx,[ebx+eax*4]
		mov		THIS.amc,ecx
		mov		ebx,OP(0).egcount			// egcount += egdcount
		mov		ecx,OP(0).egdcount
		mov		THIS.pmc,edx
		add		ebx,ecx
		mov		edx,OP(0).eglimit			// egcount < eglimit ?
		mov		OP(0).egcount,ebx
		cmp		ebx,edx
		jnb		op1_phase
op1_1:
		// ebx = egcount
		shr		ebx,FM_EGCBITS				// eax = tllinear * dltable[egcount]
		mov		eax,dltable[ebx * 4]
		mov		cl,OP(0).amon
		imul	eax,OP(0).tllinear			// ebx = 32bit
		test	cl,cl
		jz		op1_namon

		mul		THIS.amc
		mov		ebx,edx
		jmp		op1_2
op1_namon:
		shr		eax,16
		mov		ebx,eax
op1_2:
		// ebx = egout
		mov		eax,OP(0).pgdcount
		mul		THIS.pmc
		mov		edi,OP(0).pgcount			// pgcount += pgdcount
		shrd	eax,edx,16
		mov		ecx,THIS.fb
		add		eax,edi
		mov		OP(0).pgcount,eax
		cmp		ecx,31
		mov		edx,OP(0).out

		jne		op1_fb

		shr		eax,20+FM_PGBITS-FM_OPSINBITS-2
		and		eax,(FM_OPSINENTS-1)*4
		imul	ebx,sinetable[eax]
		add		edx,ebx
		mov		OP(0).out,ebx
		shr		edx,1
		jmp		op1_3

op1_fb:
		// ebx = A   eax = 
		lea		edi,[edx*2+edx]				// edi = last out
		sal		edx,2 + IS2EC_SHIFT
		sar		edx,cl
		add		eax,edx						// eax = +FB
		sar		eax,20+FM_PGBITS-FM_OPSINBITS-2
		and		eax,(FM_OPSINENTS-1)*4
		imul	ebx,sinetable[eax]
		lea		edx,[ebx*4+ebx]
		mov		OP(0).out,ebx
		add		edx,edi
		sar		edx,3
op1_3:
		mov		BUF(0),edx
	}
//op2:
	OPCALC(2)
	__asm { add eax, ecx }
	__asm { mov OP(1).out, ecx }
	__asm { sar eax, 1 }
	__asm {	add	[ebx],eax }

	OPCALC(3)
	__asm { add eax, ecx }
	__asm { mov OP(2).out, ecx }
	__asm { sar eax, 1 }
	__asm {	add	[ebx],eax }
	
	OPCALC(4)
	__asm
	{
		mov OP(3).out, ecx
		add eax,ecx
		pop	edi
		mov ecx,[ebx]
		sar eax,1
		pop	esi
		add	eax,ecx
		pop	ebx
		pop ecx
		pop	ebp
		ret	4
	}

op1_phase:
	op[0].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(0).egcount
	__asm jmp	op1_1
op2_phase:
	op[1].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(1).egcount
	__asm jmp	op2_1
op3_phase:
	op[2].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(2).egcount
	__asm jmp	op3_1
op4_phase:
	op[3].ShiftPhase(Operator::next);
	__asm mov	ebx,OP(3).egcount
	__asm jmp	op4_1

	return 0;
}

#undef OPCALC
